/* trees.C--Example from Chapter 7 of User's Guide */

/* This program creates a table and a bar chart plot from a
   set of tree diameter readings, and calculates hollow avilability for
   selected hollow users in Western Australia */




#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <math.h>

/* Prototypes */

void  get_trees(void);
void  save_temps(void);
void  read_temps(void);
void  output(void);
void  restart(void);
void  print(void);

/* Global defines */


#define TRUE      1
#define READINGS  400

/* Global data structures */
   float ps = 0;
   float count1 = 0; float count2 = 0;
   float x[READINGS] ;
   float y[READINGS];
   float diff[READINGS];
   float tot1 = 0; float tot2 = 0;  float tot = 0;
   float C = 0; float sor = 0; float horn = 0;
   float d2 = 0; float d3 = 0; float mor = 0;
   float trees[READINGS][2];
   float count = 0; float marg[2]; float men[2]; float h[2]; float sd[2];
   float dis1 = 0;  float sdiv[2]; float isd[2]; float sdr[2]; float isdr[2];
   float dis2 = 0;  float sdivr[2]; float hev[2]; float simev[2];
   float dis3 = 0;

int  main(void)
{

      while (TRUE)

   {
        clrscr();
	printf("\tCOMMUNITY SIMILARITY CALCULATOR");
	printf("\n\t\tprepared by Bill McComb");

      
      printf("\nMenu\n\n");
      
      printf("\tE - Enter data to a scratchpad\n");
      printf("\tS - Save scratchpad to disk\n");
      printf("\tR - Read disk file to scratchpad\n");
      printf("\tF - Save results to a disk file for later printing\n");
      printf("\tP - Send the results to the line printer\n");
      printf("\tN - Restart the program (enter new data)\n");
      printf("\tX - Exit the program\n");
      printf("\nPress one of the above keys: ");

      switch (toupper(getche()))
      {
	 
	 case 'E': get_trees();  break;
	 case 'S': save_temps(); break;
	 case 'R': read_temps(); break;
	 case 'F': output(); break;
	 case 'P': print(); break;
	 case 'N': restart(); break;
	 case 'X': exit(0);

      }
   }
}

/* Function definitions */
void  get_trees(void)
{
   
   int reading = 0;
   char inbuf[512];
   float x9 = 0; float y9 = 0; float g1 = 0; float g2 = 0; float g3 = 0;
   float p = 0; float z[READINGS]; float l1 = 0; float l2 = 0;
   float h1 = 0; float h2 = 0; float h3 = 0; float h4 = 0; float h5 = 0;
   float g4 = 0; float tot17 = 0; float tot27 = 0;
      ps = 0;
   count1 = 0; count2 = 0;
   x[READINGS] = 0;
   y[READINGS] = 0;
   diff[READINGS] = 0;
   tot1 = 0; tot2 = 0;  tot = 0;
   C = 0; sor = 0; horn = 0;
   d2 = 0; d3 = 0; mor = 0;
   count = 0; marg[2] = 0; men[2] = 0; h[2] = 0;sd[2] = 0;
   dis1 = 0;  sdiv[2] = 0; isd[2] = 0; sdr[2] = 0; isdr[2] = 0;
   dis2 = 0;  sdivr[2] = 0; hev[2] = 0; simev[2] = 0;
   dis3 = 0;

	   clrscr();
	printf("\nEnter the number of individuals of each species in community 'a'");
	printf(" followed by the number in community 'b'. End with -1. \n");

	for (reading = 0; reading < READINGS; reading++)
		{
		printf("\nEnter the number of individuals in community 'a'");
		gets(inbuf);
		sscanf(inbuf, "%f", &trees[reading][1]);
		if (trees[reading][1] == -1)
			break;

		
		printf("\nEnter the number of individuals in community 'b'");
		gets(inbuf);
		sscanf(inbuf, "%f", &trees[reading][2]);

		if (trees[reading][1] == -1)
			break;
                /*Begin calculations here*/

	count += 1;
        tot1 += trees[reading][1];
        tot2 += trees[reading][2];

	if (trees[reading][1] && trees[reading][2] > 0)
	C += 1;

	if (trees[reading][1] > 0)
	count1 += 1;

	if (trees[reading][2] > 0)
      	count2 += 1;
	
	 
	 x9 += trees[reading][1] * (trees[reading][1] - 1);
	 y9 += trees[reading][2] * (trees[reading][2] - 1);

	 if (trees[reading][1] > 0)
	 g1 += trees[reading][1] * (log(trees[reading][1]));

	 if (trees[reading][2] > 0)
	 g2 += trees[reading][2] * (log(trees[reading][2]));

	 d2 += pow((trees[reading][1] - trees[reading][2]), 2);
	 d3 += pow((trees[reading][1] - trees[reading][2]) / (trees[reading][1] + trees[reading][2]), 2);
	 p += trees[reading][1] * trees[reading][2];
	 z[reading] = trees[reading][1] + trees[reading][2];

	 if (z[reading] > 0)
	 g3 += z[reading] * log(z[reading]);

	 tot = tot1 + tot2;
	 
	 sor = 2 * C / (count1 + count2);
	 l1 = x9 / tot1 / (tot1 - 1);
	 l2 = y9 / tot2 / (tot2 - 1);
	 mor = 2 * p / ((l1 + l2) * tot1 * tot2);
	 g4 = tot * log(tot);
	 if (tot1 > 0)
	 h1 = (tot1 * log(tot1) - g1) / tot1;
	 if (tot2 > 0)
	 h2 = (tot2 * log(tot2) - g2) / tot2;
	 h3 = (g4 - g3) / tot;
	 h4 = (g4 - g1 - g2) / tot;
	 h5 = (tot1 * h1 + tot2 * h2) / tot;
	 horn = (h4 - h3) / (h4 - h5);
	 dis1 = sqrt(d2);
	 dis2 = sqrt(d2 / count);
	 dis3 = sqrt(d3 / count);
	 tot17 += pow(trees[reading][1], 2);
	 tot27 += pow(trees[reading][2], 2);
	 if (tot1 > 0)
	 marg[1] = (count1 - 1) / (log10(tot1));
	 if (tot2 > 0)
	 marg[2] = (count2 - 1) / (log10(tot2));
	 sd[1] = x9 / tot1 / (tot1 - 1);
	 sd[2] = y9 / tot2 / (tot2 - 1);
	 sdiv[1] = 1 - sd[1];
	 sdiv[2] = 1 - sd[2];
	 isd[1] = 1 / sd[1];
	 isd[2] = 1 / sd[2];
	 men[1] = count1 / sqrt(tot1);
	 men[2] = count2 / sqrt(tot2);
         sdr[1] = tot17 / pow(tot1, 2);
	 sdr[2] = tot27 / pow(tot2, 2);
	 sdivr[1] = 1 - sdr[1];
	 sdivr[2] = 1 - sdr[2];
	 isdr[1] = 1 / sdr[1];
	 isdr[2] = 1 / sdr[2];
	 
	 
       }
	       for (reading = 0; reading < count; reading++)
      {
	 if (trees[reading][1] > 0)
	 h[1] += (trees[reading][1] / tot1) * (log10(trees[reading][1] / tot1));
	 if (trees[reading][2] > 0)
	 h[2] += (trees[reading][2] / tot2) * (log10(trees[reading][2] / tot2));
         x[reading] = trees[reading][1] / tot1;
	 y[reading] = trees[reading][2] / tot2;
	 if (x[reading] - y[reading] >= 0)
	 diff[reading] = y[reading];
	 
	 else diff[reading] = x[reading];
	  ps += diff[reading];
	 }
	 simev[1] = (sdiv[1]) / ((count1 - 1) * tot1 / count1 / (tot1 - 1));
	 simev[2] = (sdiv[2]) / ((count2 - 1) * tot2 / count2 / (tot2 - 1));

	 if (count1 > 0)
	 hev[1] = -1 * h[1] / log10(count1);
	 if (count2 > 0)
	 hev[2] = -1 * h[2] / log10(count2);

	printf("\nNumber of species in community a = %5.0f", count1);
	printf("\nNumber of species in community b = %5.0f", count2);
	printf("\nPercent Similarity = %f", ps);
	printf("\nJaccard Coefficient = %f", C / count);
	printf("\nSorensen Coefficient = %f", sor);
	printf("\nDissimilarity Index 1 = %f", dis1);
	printf("\nDissimilarity Index 2 = %f", dis2);
	printf("\nDissimilarity Index 3 = %f", dis3);
	printf("\nMorista's index = %f", mor);
	printf("\nHorn's index = %f\n", horn);


	/* end calculations here*/

	printf("\nPress any key to continue\n\n");

        getch();                               /* Wait for a key press */

	printf("\nDiversity values for community 1\n");
	printf("\nMargalef diversity = %f", marg[1]);
	printf("\nMenhinick diversity = %f", men[1]);
	printf("\nSimpson's dominance (random sample) = %f", sd[1]);
	printf("\nSimpson's diversity (random sample) = %f", sdiv[1]);
	printf("\nInverse Simpson's diversity (random sample) = %f", isd[1]);
	printf("\nSimpson's dominance (nonrandom sample) = %f", sdr[1]);
	printf("\nSimpson's diversity (nonrandom sample) = %f", sdivr[1]);
	printf("\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[1]);
	printf("\nShannon Diversity base 10 = %f", h[1] * -1);
	printf("\nSimpson's evenness = %f", simev[1]);
	printf("\nShannon evenness = %f\n\n", hev[1]);

	printf("Press any key to continue\n\n");

        getch();                               /* Wait for a key press */
	clrscr();

	printf("\nDiversity values for community 2\n");
	printf("\nMargalef diversity = %f", marg[2]);
	printf("\nMenhinick diversity = %f", men[2]);
	printf("\nSimpson's dominance (random sample) = %f", sd[2]);
	printf("\nSimpson's diversity (random sample) = %f", sdiv[2]);
	printf("\nInverse Simpson's diversity (random sample) = %f", isd[2]);
	printf("\nSimpson's dominance (nonrandom sample) = %f", sdr[2]);
	printf("\nSimpson's diversity (nonrandom sample) = %f", sdivr[2]);
	printf("\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[2]);
	printf("\nShannon Diversity = %f", h[2] * -1);
	printf("\nSimpson's evenness = %f", simev[2]);
	printf("\nShannon evenness = %f\n\n", hev[2]);

        printf("Press any key to continue");

        getch();                               /* Wait for a key press */
	clrscr();

}

void  save_temps(void)
{
   FILE *outfile;
   char file_name[512];
   int reading = 0;

   printf("\nSave to what filename? ");
   while (kbhit());  /* "eat" any char already in keyboard buffer */
   gets(file_name);

   if ((outfile = fopen(file_name,"w")) == NULL)
   {
      perror("\nOpen failed! ");
      return;
   }
	
	for (reading = 0; reading < count; reading++)
	fprintf(outfile, "%f %f\n", trees[reading][1], trees[reading][2]);

	fprintf(outfile, "%d", -1);

	fclose(outfile);
}

void  read_temps(void)
{
   FILE *infile;

   char file_name[512] = "test";
   int reading = 0;
   float x9 = 0; float y9 = 0; float g1 = 0; float g2 = 0; float g3 = 0;
   float p = 0; float z[READINGS]; float l1 = 0; float l2 = 0;
   float h1 = 0; float h2 = 0; float h3 = 0; float h4 = 0; float h5 = 0;
   float g4 = 0; float tot17 = 0; float tot27 = 0; 
   tot1 = 0; tot2 = 0;  tot = 0;
   C = 0; sor = 0; horn = 0;
   d2 = 0; d3 = 0; mor = 0;
   count = 0; 
   dis1 = 0;  
   dis2 = 0;
   dis3 = 0;
   marg[2] = 0; men[2] = 0; h[2] = 0;sd[2] = 0;
   sdiv[2] = 0; isd[2] = 0; sdr[2] = 0; isdr[2] = 0;
   sdivr[2] = 0; hev[2] = 0; simev[2] = 0;

   printf("\n\n\n");
   printf("\nNOTE: ");
   printf("\nEach line in your ASCII file should contain the number of ");
   printf("\nindividuals of species 'x' in community 'a' followed by a ");
   printf("\nspace and then the number of species 'x' in community 'b'");
   printf("\n(e.g., 23 10). The last line should contain a -1 in the first 2 columns.");
   printf("\nRead from which file? ");
   while (kbhit());  /* "eat" any char already in keyboard buffer */
   gets(file_name);

   if ((infile = fopen(file_name,"r")) == NULL)
   {
      perror("\n\aOpen failed! ");
         getch();                               /* Wait for a key press */
	clrscr();
      return;
   }

   for (reading = 1; reading < READINGS; reading++)

   {
	fscanf(infile, "%f %f\n", &trees[reading][1], &trees[reading][2]);

	if (trees[reading][1] == -1) break;

        /*Begin calculations here*/

	count += 1;
        tot1 += trees[reading][1];
        tot2 += trees[reading][2];

	if (trees[reading][1] && trees[reading][2] > 0)
	C += 1;

	if (trees[reading][1] > 0)
	count1 += 1;

	if (trees[reading][2] > 0)
      	count2 += 1;
	
	 
	 x9 += trees[reading][1] * (trees[reading][1] - 1);
	 y9 += trees[reading][2] * (trees[reading][2] - 1);

	 if (trees[reading][1] > 0)
	 g1 += trees[reading][1] * (log(trees[reading][1]));

	 if (trees[reading][2] > 0)
	 g2 += trees[reading][2] * (log(trees[reading][2]));

	 d2 += pow((trees[reading][1] - trees[reading][2]), 2);
	 d3 += pow((trees[reading][1] - trees[reading][2]) / (trees[reading][1] + trees[reading][2]), 2);
	 p += trees[reading][1] * trees[reading][2];
	 z[reading] = trees[reading][1] + trees[reading][2];

	 if (z[reading] > 0)
	 g3 += z[reading] * log(z[reading]);

	 tot = tot1 + tot2;
	 
	 sor = 2 * C / (count1 + count2);
	 l1 = x9 / tot1 / (tot1 - 1);
	 l2 = y9 / tot2 / (tot2 - 1);
	 mor = 2 * p / ((l1 + l2) * tot1 * tot2);
	 if (tot > 0)
	 g4 = tot * log(tot);
	 if (tot1 > 0)
	 h1 = (tot1 * log(tot1) - g1) / tot1;
	 if (tot2 > 0)
	 h2 = (tot2 * log(tot2) - g2) / tot2;
	 h3 = (g4 - g3) / tot;
	 h4 = (g4 - g1 - g2) / tot;
	 h5 = (tot1 * h1 + tot2 * h2) / tot;
	 horn = (h4 - h3) / (h4 - h5);
	 dis1 = sqrt(d2);
	 dis2 = sqrt(d2 / count);
	 dis3 = sqrt(d3 / count);
	 tot17 += pow(trees[reading][1], 2);
	 tot27 += pow(trees[reading][2], 2);
         if (tot1 > 0)
	 marg[1] = (count1 - 1) / (log10(tot1));
	 if (tot2 > 0)
	 marg[2] = (count2 - 1) / (log10(tot2));
	 sd[1] = x9 / tot1 / (tot1 - 1);
	 sd[2] = y9 / tot2 / (tot2 - 1);
	 sdiv[1] = 1 - sd[1];
	 sdiv[2] = 1 - sd[2];
	 isd[1] = 1 / sd[1];
	 isd[2] = 1 / sd[2];
	 men[1] = count1 / sqrt(tot1);
	 men[2] = count2 / sqrt(tot2);
         sdr[1] = tot17 / pow(tot1, 2);
	 sdr[2] = tot27 / pow(tot2, 2);
	 sdivr[1] = 1 - sdr[1];
	 sdivr[2] = 1 - sdr[2];
	 isdr[1] = 1 / sdr[1];
	 isdr[2] = 1 / sdr[2];
	}
	   fclose(infile);
	       for (reading = 0; reading < count + 1; reading++)
      {

	 if (trees[reading][1] > 0)
	 h[1] += (trees[reading][1] / tot1) * (log10(trees[reading][1] / tot1));
	 if (trees[reading][2] > 0)
	 h[2] += (trees[reading][2] / tot2) * (log10(trees[reading][2] / tot2));
         x[reading] = trees[reading][1] / tot1;
	 y[reading] = trees[reading][2] / tot2;
	 if (x[reading] - y[reading] >= 0)
	 diff[reading] = y[reading];
	 
	 else diff[reading] = x[reading];
         ps += diff[reading];
	}
	 simev[1] = (1 - sd[1]) / ((count1 - 1) * tot1 / count1 / (tot1 - 1));
	 simev[2] = (1 - sd[2]) / ((count2 - 1) * tot2 / count2 / (tot2 - 1));
	 if (count1 > 0)
	 hev[1] = -1 * h[1] / log10(count1);
	 if (count2 > 0)
	 hev[2] = -1 * h[2] / log10(count2);

	printf("\nNumber of species in community a = %5.0f", count1);
	printf("\nNumber of species in community b = %5.0f", count2);
	printf("\nPercent Similarity = %f", ps);
	printf("\nJaccard Coefficient = %f", C / count);
	printf("\nSorensen Coefficient = %f", sor);
	printf("\nDissimilarity Index 1 = %f", dis1);
	printf("\nDissimilarity Index 2 = %f", dis2);
	printf("\nDissimilarity Index 3 = %f", dis3);
	printf("\nMorista's index = %f", mor);
	printf("\nHorn's index = %f\n", horn);


	/* end calculations here*/

	printf("\nPress any key to continue\n\n");

        getch();                               /* Wait for a key press */

	printf("\nDiversity values for community 1\n");
	printf("\nMargalef diversity = %f", marg[1]);
	printf("\nMenhinick diversity = %f", men[1]);
	printf("\nSimpson's dominance (random sample) = %f", sd[1]);
	printf("\nSimpson's diversity (random sample) = %f", sdiv[1]);
	printf("\nInverse Simpson's diversity (random sample) = %f", isd[1]);
	printf("\nSimpson's dominance (nonrandom sample) = %f", sdr[1]);
	printf("\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[1]);
	printf("\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[1]);
	printf("\nShannon Diversity base 10 = %f", h[1] * -1);
	printf("\nSimpson's evenness = %f", simev[1]);
	printf("\nShannon evenness = %f\n\n", hev[1]);

	printf("Press any key to continue\n\n");

        getch();                               /* Wait for a key press */
	clrscr();

	printf("\nDiversity values for community 2\n");
	printf("\nMargalef diversity = %f", marg[2]);
	printf("\nMenhinick diversity = %f", men[2]);
	printf("\nSimpson's dominance (random sample) = %f", sd[2]);
	printf("\nSimpson's diversity (random sample) = %f", sdiv[2]);
	printf("\nInverse Simpson's diversity (random sample) = %f", isd[2]);
	printf("\nSimpson's dominance (nonrandom sample) = %f", sdr[2]);
	printf("\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[2]);
	printf("\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[2]);
	printf("\nShannon Diversity = %f", h[2] * -1);
	printf("\nSimpson's evenness = %f", simev[2]);
	printf("\nShannon evenness = %f\n\n", hev[2]);

        printf("Press any key to continue");

        getch();                               /* Wait for a key press */
	clrscr();

	
}


void  output(void)
{
   FILE *outfile;
   char file_name[512];
   char inbuf[512];


   {
	char inbuf[512];
	char title1[512];
	char title2[512];
	char title3[512];
	char title4[512];
	char title5[512];
	   clrscr();
	printf("\nEnter the title for your output file \n");
            	gets(inbuf);
		sscanf(inbuf, " %s %s %s %s %s ", &title1, &title2, &title3, &title4, &title5);


   printf("\nSave to what filename? ");
   while (kbhit());  /* "eat" any char already in keyboard buffer */
   gets(file_name);

   if ((outfile = fopen(file_name,"a+")) == NULL)
   {
      perror("\n\aOpen failed! ");
      return;
   }


	fprintf(outfile,"\n%s %s %s %s %s ", title1, title2, title3, title4, title5);
	fprintf(outfile,"\nNumber of species in community a = %5.0f", count1);
	fprintf(outfile,"\nNumber of species in community b = %5.0f", count2);
	fprintf(outfile,"\nPercent Similarity = %f", ps);
	fprintf(outfile,"\nJaccard Coefficient = %f", C / count);
	fprintf(outfile,"\nSorensen Coefficient = %f", sor);
	fprintf(outfile,"\nDissimilarity Index 1 = %f", dis1);
	fprintf(outfile,"\nDissimilarity Index 2 = %f", dis2);
	fprintf(outfile,"\nDissimilarity Index 3 = %f", dis3);
	fprintf(outfile,"\nMorista's index = %f", mor);
	fprintf(outfile,"\nHorn's index = %f\n\n", horn);

	fprintf(outfile,"\nDiversity values for community 1\n");
	fprintf(outfile,"\nMargalef diversity = %f", marg[1]);
	fprintf(outfile,"\nMenhinick diversity = %f", men[1]);
	fprintf(outfile,"\nSimpson's dominance (random sample) = %f", sd[1]);
	fprintf(outfile,"\nSimpson's diversity (random sample) = %f", sdiv[1]);
	fprintf(outfile,"\nInverse Simpson's diversity (random sample) = %f", isd[1]);
	fprintf(outfile,"\nSimpson's dominance (nonrandom sample) = %f", sdr[1]);
	fprintf(outfile,"\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[1]);
	fprintf(outfile,"\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[1]);
	fprintf(outfile,"\nShannon Diversity base 10 = %f", h[1] * -1);

	fprintf(outfile,"\nSimpson's evenness = %f", simev[1]);
	fprintf(outfile,"\nShannon evenness = %f\n\n", hev[1]);

	fprintf(outfile,"\nDiversity values for community 2\n");
	fprintf(outfile,"\nMargalef diversity = %f", marg[2]);
	fprintf(outfile,"\nMenhinick diversity = %f", men[2]);
	fprintf(outfile,"\nSimpson's dominance (random sample) = %f", sd[2]);
	fprintf(outfile,"\nSimpson's diversity (random sample) = %f", sdiv[2]);
	fprintf(outfile,"\nInverse Simpson's diversity (random sample) = %f", isd[2]);
	fprintf(outfile,"\nSimpson's dominance (nonrandom sample) = %f", sdr[2]);
	fprintf(outfile,"\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[2]);
	fprintf(outfile,"\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[2]);
	fprintf(outfile,"\nShannon Diversity base 10 = %f", h[2] * -1);
	
	fprintf(outfile,"\nSimpson's evenness = %f", simev[2]);
	fprintf(outfile,"\nShannon evenness = %f\n\n", hev[2]);
        fclose(outfile);
   }

}
void  restart(void)

{  	int reading = 0; count = 0;
	ps = 0;
	count1 = 0; count2 = 0;
	tot1 = 0; tot2 = 0;
        tot1 = 0; tot2 = 0;  tot = 0;
   C = 0; sor = 0; horn = 0;
   d2 = 0; d3 = 0; mor = 0;
   count = 0; 
   dis1 = 0;  
   dis2 = 0;
   dis3 = 0;
   marg[2] = 0; men[2] = 0; h[2] = 0; sd[2] = 0;
   sdiv[2] = 0; isd[2] = 0; sdr[2] = 0; isdr[2] = 0;
   sdivr[2] = 0; hev[2] = 0; simev[2] = 0;
   marg[1] = 0; men[1] = 0; h[1] = 0;sd[1] = 0;
   sdiv[1] = 0; isd[1] = 0; sdr[1] = 0; isdr[1] = 0;
   sdivr[1] = 0; hev[1] = 0; simev[1] = 0;



	for (reading = 0; reading < READINGS; reading++)
     {
	trees[reading][1] = 0;
        trees[reading][2] = 0;
        diff[reading] = 0;
	x[reading] = 0;
	y[reading] = 0;
     }
	
}


void  print(void)

{
   char inbuf[512];
	char title1[512];
	char title2[512];
	char title3[512];
	char title4[512];
	char title5[512];
	   clrscr();
	printf("\nEnter the title for your output \n");
            	gets(inbuf);
		sscanf(inbuf, " %s %s %s %s %s ", &title1, &title2, &title3, &title4, &title5);

   	fprintf(stdprn,"\n%s %s %s %s %s ", title1, title2, title3, title4, title5);
	fprintf(stdprn,"\nNumber of species in community a = %5.0f", count1);
	fprintf(stdprn,"\nNumber of species in community b = %5.0f", count2);
	fprintf(stdprn,"\nPercent Similarity = %f", ps);
	fprintf(stdprn,"\nJaccard Coefficient = %f", C / count);
	fprintf(stdprn,"\nSorensen Coefficient = %f", sor);
	fprintf(stdprn,"\nDissimilarity Index 1 = %f", dis1);
	fprintf(stdprn,"\nDissimilarity Index 2 = %f", dis2);
	fprintf(stdprn,"\nDissimilarity Index 3 = %f", dis3);
	fprintf(stdprn,"\nMorista's index = %f", mor);
	fprintf(stdprn,"\nHorn's index = %f\n\n", horn);

	fprintf(stdprn,"\nDiversity values for community 1\n");
	fprintf(stdprn,"\nMargalef diversity = %f", marg[1]);
	fprintf(stdprn,"\nMenhinick diversity = %f", men[1]);
	fprintf(stdprn,"\nSimpson's dominance (random sample) = %f", sd[1]);
	fprintf(stdprn,"\nSimpson's diversity (random sample) = %f", sdiv[1]);
	fprintf(stdprn,"\nInverse Simpson's diversity (random sample) = %f", isd[1]);
	fprintf(stdprn,"\nSimpson's dominance (nonrandom sample) = %f", sdr[1]);
	fprintf(stdprn,"\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[1]);
	fprintf(stdprn,"\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[1]);
	fprintf(stdprn,"\nShannon Diversity base 10 = %f", h[1] * -1);

	fprintf(stdprn,"\nSimpson's evenness = %f", simev[1]);
	fprintf(stdprn,"\nShannon evenness = %f\n\n", hev[1]);

	fprintf(stdprn,"\nDiversity values for community 2\n");
	fprintf(stdprn,"\nMargalef diversity = %f", marg[2]);
	fprintf(stdprn,"\nMenhinick diversity = %f", men[2]);
	fprintf(stdprn,"\nSimpson's dominance (random sample) = %f", sd[2]);
	fprintf(stdprn,"\nSimpson's diversity (random sample) = %f", sdiv[2]);
	fprintf(stdprn,"\nInverse Simpson's diversity (random sample) = %f", isd[2]);
	fprintf(stdprn,"\nSimpson's dominance (nonrandom sample) = %f", sdr[2]);
	fprintf(stdprn,"\nSimpson's diversity (nonrandom sample) = %f", 1 - sdr[2]);
	fprintf(stdprn,"\nInverse Simpson's diversity (nonrandom sample) = %f", isdr[2]);
	fprintf(stdprn,"\nShannon Diversity base 10 = %f", h[2] * -1);
	
	fprintf(stdprn,"\nSimpson's evenness = %f", simev[2]);
	fprintf(stdprn,"\nShannon evenness = %f\n\n", hev[2]);
	
}
